#include "stdafx.h"
#include "TrayTest.h"
#include "MainFrm.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

#pragma warning(suppress: 26426)
ATL::CComModule _Module;

#pragma warning(suppress: 26426)
CTrayApp theApp;


#pragma warning(suppress: 26440 26433)
BEGIN_MESSAGE_MAP(CTrayApp, CWinApp) //NOLINT(clang-diagnostic-unused-local-typedef, modernize-avoid-c-arrays)
  ON_COMMAND(ID_APP_ABOUT, &CTrayApp::OnAppAbout)
END_MESSAGE_MAP()

CTrayApp::CTrayApp() noexcept : m_pCurrentAboutDlg{nullptr}
{
}

BOOL CTrayApp::InitInstance()
{
  //Initialize ATL
#pragma warning(suppress: 26490)
  _Module.Init(reinterpret_cast<ATL::_ATL_OBJMAP_ENTRY*>(-1), m_hInstance);

#pragma warning(suppress: 26400 26403 26409)
  auto pMainFrame{new CMainFrame};
  m_pMainWnd = pMainFrame;
  if (!pMainFrame->Create(nullptr, _T("Traytest")))
    return FALSE;

  m_pMainWnd->ShowWindow(SW_HIDE);
  m_pMainWnd->UpdateWindow();

  return TRUE;
}

int CTrayApp::ExitInstance()
{
  //Terminate ATL
  _Module.Term();

  return __super::ExitInstance();
}

void CTrayApp::OnAppAbout()
{
  //avoid bringing up two versions of the dialog
  if (m_pCurrentAboutDlg != nullptr)
  {
    m_pCurrentAboutDlg->SetForegroundWindow();
    return;
  }

  //Show the window
  CDialog aboutdlg{IDD_ABOUTBOX};
  m_pCurrentAboutDlg = &aboutdlg;
  aboutdlg.DoModal();
  m_pCurrentAboutDlg = nullptr;
}
