#include "stdafx.h"
#include "resource.h"
#include "MainFrm.h"

#pragma warning(suppress: 26426)
CAppModule _Module;


int Run(_In_opt_z_ LPTSTR /*lpstrCmdLine*/ = nullptr, _In_ int nCmdShow = SW_SHOWDEFAULT)
{
  CMessageLoop theLoop;
#pragma warning(suppress: 26486)
  _Module.AddMessageLoop(&theLoop);
  CMainFrame wndMain;
  if (wndMain.CreateEx() == nullptr)
  {
    ATLTRACE(_T("Main window creation failed!\n"));
    return 0;
  }
  wndMain.ShowWindow(nCmdShow);
  const int nRet{theLoop.Run()};
  _Module.RemoveMessageLoop();
  return nRet;
}

int WINAPI _tWinMain(_In_ HINSTANCE hInstance, _In_opt_ HINSTANCE /*hPrevInstance*/, _In_ LPTSTR lpstrCmdLine, _In_ int /*nCmdShow*/)
{
  AtlInitCommonControls(ICC_COOL_CLASSES | ICC_BAR_CLASSES);
#pragma warning(suppress: 26490)
  const HRESULT hr{_Module.Init(reinterpret_cast<ATL::_ATL_OBJMAP_ENTRY*>(-1), hInstance)};
#ifdef _DEBUG
#pragma warning(suppress: 26477)
  ATLASSERT(SUCCEEDED(hr));
#else
  UNREFERENCED_PARAMETER(hr);
#endif
  const int nRet{Run(lpstrCmdLine, SW_HIDE)};
  _Module.Term();
  return nRet;
}
